#include"motor.h"

Motor::Motor(int e, int a,int b,int c,int d)
{
  en=e; // Motorpins merken
  m1=a;
  m2=b;
  i1=c;
  i2=d;
  
  pinMode(en,OUTPUT); // Pins konfigurieren
  pinMode(m1,OUTPUT);
  pinMode(m2,OUTPUT);
  pinMode(i1,INPUT);
  pinMode(i2,INPUT);

  digitalWrite(en,LOW); // Motor erst mal ausschalten
  digitalWrite(m1,LOW);
  digitalWrite(m2,LOW);

  int h = digitalRead(i1)+2*digitalRead(i2); // Aktuellen Zustand ermitteln
  int i;
  for(i=0;i<3;i++) if (st[i]==h) pos=i;
}

void Motor::richtung()
{
  int h = digitalRead(i1)+2*digitalRead(i2);
  if (st[(pos+3)%4]==h)
  {
    steps--;  
    pos=(pos+3)%4;
  }  
  else if (st[(pos+1)%4]==h)
  {
    steps++;  
    pos=(pos+1)%4;
  }
}

long Motor::getSteps()
{
  return steps;
}

void Motor::power(int p)
{
  p=constrain(p,-255,255);
  if(p>=0)
  {
    analogWrite(en,p);
    digitalWrite(m1,HIGH);
    digitalWrite(m2,LOW);
  }
  else
  {
    analogWrite(en,-p);
    digitalWrite(m2,HIGH);
    digitalWrite(m1,LOW);
  }
}

